import Terrain.Triangulation;
import java.applet.*;
import java.awt.*;

public class DrawPanel extends Panel {
  public Triangulation t = null;
  Graphics graphics = null;
  
  public DrawPanel() {
    t = null;
    setBackground(Color.white);
    setForeground(Color.black);
  }
    
  public boolean handleEvent(Event e) {
    if (t == null) { t = new Triangulation(1000); t.debug_gr = getGraphics();}
    if (graphics == null) { 
      t.debug_gr = graphics = getGraphics();
    }
    switch (e.id) {
    case Event.MOUSE_DOWN:
      graphics.drawOval(e.x-3, e.y-3, 6, 6);
      return true;
      
    case Event.MOUSE_UP:
      if (e.shiftDown()) 
	t.delete(graphics, new Terrain.Point(e.x, e.y));
      else 
	t.insert(graphics, new Terrain.Point(e.x, e.y));
      repaint();
      return true;
      
    case Event.MOUSE_DRAG:
      return true;
      
    case Event.WINDOW_DESTROY:
      System.exit(0);
      return true;

    default:
      return false;
    }
  }
  
  public void repaint() {
    update(getGraphics());
  }
  public void paint(Graphics g) {
    if (t != null) t.draw(g);
  }
}

class DrawControls extends Panel {
  DrawPanel target;
  private Choice displayChoice;
  private String dispString;

  public DrawControls(DrawPanel target) {
    this.target = target;
    setLayout(new FlowLayout());
    setBackground(Color.lightGray);
    displayChoice = new Choice();
    displayChoice.addItem("Delaunay");
    displayChoice.addItem("Voronoi");
    displayChoice.addItem("Crust");
    add(displayChoice);
    add(new Button("Reset"));
    add(new Button("Repaint"));
//    add(new Button("Quit"));
  }
  
  public void paint(Graphics g) {
    Rectangle r = bounds();
    g.setColor(Color.lightGray);
    g.draw3DRect(0, 0, r.width, r.height, false);
  }
  
  public boolean action(Event e, Object arg) {
    if (target.t == null) target.t = new Triangulation(1000);
    if (e.target instanceof Button) {
    	String buttonName = (String)arg;
	if (buttonName.equals("Quit")) System.exit(0);
	if (buttonName.equals("Repaint")) target.repaint();
	if (buttonName.equals("Reset")) {
	  target.t = new Triangulation(1000);
	  target.repaint();
	}
      }
    else if (e.target instanceof Choice) {
      dispString = (String)arg;
      displayChoice.select(dispString);
      if (dispString.equals("Delaunay")) 
	target.t.delVorCrust = target.t.DELAUNAY;
      else if (dispString.equals("Voronoi")) 
	target.t.delVorCrust = target.t.VORONOI;
      else target.t.delVorCrust = target.t.CRUST;
      target.repaint();
    }
    return true;
  }
}

